<?php
/*
扫码下单接口
 */

header("Content-type: text/html; charset=utf-8");
require_once "init.php";
require_once "request/TransContent.php";
require_once "request/TransDataUtils.php";

echo "\r\n";
$key="1d1edbb806e94a066f2fd1e68a659f53";

$params = new TransContent();
$params -> _set("method","POLYMERIZE_MAIN_SWEPTN");
$params -> _set("version","1.0");
$params -> _set("format","JSON");
$params -> _set("merchantNo","814000473149");
$params -> _set("signType","RSA2");
$params -> _set("signContent","");
$params -> _set("sign","");

$body = new TransContent();
date_default_timezone_set("Asia/Shanghai");
$body -> _set("transNo", "DD".date("YmdHis"));//商户订单号
$body -> _set("payType", "DYNAMIC_ALL");//支付类型
$body -> _set("orderAmt", "1");//交易金额
$body -> _set("goodsInfo", "测试");//商品信息摘要
$body -> _set("returnUrl", "");//后台回调地址
$body -> _set("requestDate",date("YmdHis"));//请求时间
$body -> _set("pageUrl", "");//前台跳转地址
$body -> _set("reusePay", "TRUE");//是否支持重复扫码，默认是
$body -> _set("extend", "自定义字段");//原样返回字段
$body -> _set("memo", "");

$memo = new TransContent();
$memo -> _set("paylimit", "");//限制卡类型
$memo -> _set("timeExpire", "");//交易结束时间
//$memo -> _set("shareInfo", "100000178,1");//分账域，分账时必填
$memo -> _set("spbillCreateIp", "171.2.2.149");//终端用户IP
$memo -> _set("longitude", "171.21");//经度
$memo -> _set("latitude", "22.33");//纬度
/*
//以下银联需要上送
$memo -> _set("areaInfo", "");
$memo -> _set("appVersion", "");
$memo -> _set("deviceType", "");
$memo -> _set("deviceNo", "");
*/
$memojson = $memo -> _getArray2Json();

$body -> _set("memo",$memojson);
$bodyjson = TransDataUtils :: _array2Json($body -> _getValues());
$params -> _set("signContent",$bodyjson);


/**
* rsa 签名算法流程
* 1.先按固定格式拼接
* 2.RSA加签
*/
$signStr = "method=".$params->_get("method")."&version=".$params->_get("version")."&format=".$params->_get("format")."&merchantNo=".$params->_get("merchantNo")."&signType=".$params->_get("signType")."&signContent=".$params->_get("signContent")."&key=".$key;
echo "[请求]固定格式拼接后明文：".$signStr."\r\n";
$encrypted = $rsaUtil -> sign($signStr);
echo "[请求]RSA加签后内容：", $encrypted."\r\n";
$params -> _set("sign",$encrypted);

$array = $params -> _getValues();
echo "[客户端-发送] 内容：", TransDataUtils :: _array2Json($array)."\r\n";
$request_url = "https://test-api.huishouqian.com/api/acquiring";
$httpResult = $httpUtil -> post2($params -> _getValues(),$request_url);
echo "[服务端-响应] 内容：", $httpResult."\r\n";
$bodyArray = TransDataUtils :: _json2Array($httpResult);

/*
* rsa验签流程
 * 1.全报文除sign外按照固定格式拼接
 * 2.RSA验签
 */

$respResSign = $bodyArray['sign'];
if($bodyArray['success']){
$resSignStr = "result=".$bodyArray['result']."&success=true"."&key=".$key;
}
else{
$resSignStr = "errorCode=".$bodyArray['errorCode']."&errorMsg=".$bodyArray['errorMsg']."&success=false"."&key=".$key;
}
echo "[响应] 固定格式拼接后：".$resSignStr."\r\n";

$verifyResult = $rsaUtil -> verify($resSignStr,$respResSign);
//echo "[响应] RSA验签结果:：".$resMd5Str."\r\n";
if($verifyResult){
echo "验签通过";
}
else {
echo "验签失败";
}
?>